'use strict';
module.exports = function generate_errorMessage(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  if (it.createErrors !== false) {
    out += ' if (errors > 0) { ';
    var $dataPath = '_em_dataPath' + $lvl,
      $i = '_em_i' + $lvl,
      $key = '_em_key' + $lvl,
      $err = '_em_err' + $lvl,
      $errors = '_em_errors' + $lvl,
      $nextChar = '_em_nextChar' + $lvl,
      $errSchemaPathString = it.util.toQuotedString(it.errSchemaPath);
    out += ' var ' + ($dataPath) + ' = (dataPath || \'\') + ' + (it.errorPath) + '; ';
    if (typeof $schema == 'string') {
      out += ' var ' + ($i) + ' = 0; var ' + ($err) + '; ';
      if (!it.opts.jsonPointers) {
        out += 'var ' + ($nextChar) + ';';
      }
      out += ' var ' + ($errors) + ' = []; while (' + ($i) + ' < errors) { ' + ($err) + ' = vErrors[' + ($i) + ']; if ( ' + ($err) + '.keyword != \'' + ($keyword) + '\' && (' + ($err) + '.dataPath == ' + ($dataPath) + ' || (' + ($err) + '.dataPath.indexOf(' + ($dataPath) + ') == 0 && ';
      if (it.opts.jsonPointers) {
        out += ' ' + ($err) + '.dataPath[' + ($dataPath) + '.length] == \'/\' ';
      } else {
        out += ' (' + ($nextChar) + ' = ' + ($err) + '.dataPath[' + ($dataPath) + '.length]) == \'.\' || ' + ($nextChar) + ' == \'[\' ';
      }
      out += ')) && ' + ($err) + '.schemaPath.indexOf(' + ($errSchemaPathString) + ') == 0 && ' + ($err) + '.schemaPath[' + (it.errSchemaPath.length) + '] == \'/\') { ' + ($errors) + '.push(' + ($err) + '); vErrors.splice(' + ($i) + ', 1); errors--; } else { ' + ($i) + '++; } } if (' + ($errors) + '.length) { var err = { keyword: \'' + ($keyword) + '\' , dataPath: ' + ($dataPath) + ' , schemaPath: ' + ($errSchemaPathString) + ' + \'/' + ($keyword) + '\' , params: { errors: ' + ($errors) + ' } , message: ' + (it.util.toQuotedString($schema)) + ' ';
      if (it.opts.verbose) {
        out += ' , schema: ' + (it.util.toQuotedString($schema)) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' };  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } ';
    } else {
      var $config = it.self.getKeyword($keyword).config,
        $keywordErrors = {},
        $childErrors = {};
      for (var $key in $schema) {
        var $child = $config.CHILD_ERRORS.indexOf($key) >= 0;
        ($child ? $childErrors : $keywordErrors)[$key] = [];
      }
      if (Object.keys($keywordErrors).length) {
        out += ' var ' + ($i) + ' = 0; var ' + ($err) + '; ';
        if (!it.opts.jsonPointers) {
          out += 'var ' + ($nextChar) + ';';
        }
        out += ' var ' + ($errors) + ' = ' + (JSON.stringify($keywordErrors)) + '; while (' + ($i) + ' < errors) { ' + ($err) + ' = vErrors[' + ($i) + ']; if ( ' + ($err) + '.keyword in ' + ($errors) + ' && ' + ($err) + '.dataPath == ' + ($dataPath) + ' && ' + ($err) + '.schemaPath.indexOf(' + ($errSchemaPathString) + ') == 0 && /^\\/[^\\/]*$/.test(' + ($err) + '.schemaPath.slice(' + ($errSchemaPathString) + '.length))) { ' + ($errors) + '[' + ($err) + '.keyword].push(' + ($err) + '); vErrors.splice(' + ($i) + ', 1); errors--; } else { ' + ($i) + '++; } } for (var ' + ($key) + ' in ' + ($errors) + ') { if (' + ($errors) + '[' + ($key) + '].length) { var err = { keyword: \'' + ($keyword) + '\' , dataPath: ' + ($dataPath) + ' , schemaPath: ' + ($errSchemaPathString) + ' + \'/' + ($keyword) + '\' , params: { errors: ' + ($errors) + '[' + ($key) + '] } , message: validate.schema' + ($schemaPath) + '[' + ($key) + '] ';
        if (it.opts.verbose) {
          out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
        }
        out += ' };  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } } ';
      }
    }
    out += ' }';
  }
  return out;
}
